#!/usr/bin/python
#
# py2ch
#
# Copyright (c) 2005 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import re
import os
import cgi
#import cgitb; cgitb.enable()

import ui
import post
import config
import dolib
from monazilla import URL
from dat import *

# get cgi parameters
form = cgi.FieldStorage()
mode = form.getfirst("mode", "")
urlstr = form.getfirst("url", "")
key = form.getfirst("key", "")
off = form.getfirst("off", "")
ui.script = os.environ.get("SCRIPT_NAME", "")
if not urlstr:
    urlstr = os.environ.get("QUERY_STRING", "")

# check remote address
if not re.search(config.addr, os.environ.get("REMOTE_ADDR", "")):
    ui.print403()
    sys.exit()

if dolib.online():
    dolib.load()
    config.ua = dolib.ua

# do procedure
if mode == "menu":
    url = URL(config.menu)
    url.get(new=True)
    ui.print_menu(url)

elif mode == "cache":
    ui.print_cache(sort="file")

elif mode == "tcache":
    ui.print_cache(sort="time")

elif mode == "login":
    ok = dolib.login()
    if ok:
        ui.html_header("Logged in")
        print "<body><p>Logged in</p></body></html>"
    else:
        ui.html_header("Login Error")
        print "<body><p>Login Error</p></body></html>"

elif mode == "logout":
    ok = dolib.logout()
    ui.html_header("Logged out")
    print "<body><p>Logged out</p></body></html>"

elif urlstr == "":
    url = URL(config.menu)
    url.get(new=True)
    ui.print_menu(url)

elif mode == "remove":
    datlist = DatList()
    datlist.remove(urlstr)
    ui.html_header("removed")
    print "<body><p>Removed</p></body></html>"

elif mode == "post":
    post.post_article(urlstr, form)

elif urlstr.endswith(".dat"):       # thread
    url = Dat(urlstr)
    if mode == "update":
        live = url.get()
        ui.print_thread(url, live)
    elif mode == "viewer":
        succeed = url.dolibget()
        if succeed:
            ui.print_thread(url, False)
        else:
            ui.print_login(url)
    else:
        live = url.get(diff=True)
        ui.print_thread(url, live)

elif urlstr.find("read.cgi") >= 0:  # thread
    found = re.search(r"http://([^/]+)/test/read.cgi/([^/]+)/(\d+)", urlstr)
    if found:
        host, bbs, key = found.groups()
        url = Dat("http://%s/%s/dat/%s.dat" % (host, bbs, key))
        live = url.get(diff=True)
        ui.print_thread(url, live)

elif re.search(r"^http://[^/]+/$", urlstr):
     ui.html_header(urlstr)
     print '<body><p><a href="%s">%s</a><p></body></html>' % \
          (urlstr, urlstr)

elif urlstr.endswith("/"):      # board
    found = re.search(r"http://([^/]+)/([^/]+)/", urlstr)
    if found:
        url = URL(urlstr + "subject.txt")
        url.get(new=True)
        ui.print_board(url, found.group(1), found.group(2))

elif mode == "search":
    ui.print_search(key, off)

else:
    ui.html_header(urlstr)
    print '<body><p><a href="%s">%s</a><p></body></html>' % \
          (urlstr, urlstr)
